<script>
import { GlDisclosureDropdown, GlDisclosureDropdownGroup } from "@gitlab/ui";
import { compareVersions } from "compare-versions";
import { getVersions, getArchivesVersions } from "../services/versions";
import { isProduction } from "../utils/environment";

export default {
  components: {
    GlDisclosureDropdown,
    GlDisclosureDropdownGroup,
  },
  data() {
    return {
      versions: {},
      archiveVersions: {},
      menuItems: [],
    };
  },
  computed: {
    generatedMenuItems() {
      return [
        // Group 1
        {
          items: [
            {
              text: `${this.versions.next} (not yet released)`,
              href: this.versionedPagePath(this.versions.next),
              extraAttrs: {
                "data-testid": "next-version",
              },
            },
          ],
        },
        // Group 2
        {
          items: [
            {
              text: `${this.versions.current} (recently released)`,
              href: this.versionedPagePath(this.versions.current),
              extraAttrs: {
                "data-testid": "current-version",
              },
            },
            ...this.versions.last_minor.map((version) => ({
              text: version,
              href: this.versionedPagePath(version),
            })),
          ],
        },
        // Group 3
        {
          items: [
            ...this.versions.last_major.map((version) => ({
              text: version,
              href: this.versionedPagePath(version),
            })),
          ],
        },
      ];
    },
    legacyPath() {
      return document.querySelector('meta[name="gitlab_docs_legacy_path"]')
        ?.content;
    },
    hugoLaunchVersion() {
      return document
        .querySelector('meta[name="gitlab_docs_hugo_launch_version"]')
        ?.getAttribute("content");
    },
  },
  async created() {
    // If we're on the production domain, populate the menu with links to older versions of this page.
    // Archived and self-hosted instances only show the link to the Archives page.
    if (isProduction()) {
      try {
        this.versions = await getVersions();
        this.archiveVersions = await getArchivesVersions();
        this.menuItems = this.generatedMenuItems;
      } catch (err) {
        console.error(`Failed to fetch versions.json: ${err}`);
      }
    }

    this.menuItems.push({
      items: [{ text: "Archives", href: "https://docs.gitlab.com/archives" }],
    });
  },
  methods: {
    activeVersion() {
      return document.querySelector('meta[name="gitlab_docs_version"]')
        ?.content;
    },
    // Returns the path to the current page for a given version
    versionedPagePath(versionNumber) {
      const url = new URL(window.location.pathname, "https://docs.gitlab.com");

      // First, remove the current version from the path if it exists
      const currentVersion = this.activeVersion();
      if (currentVersion) {
        url.pathname = url.pathname.replace(`/${currentVersion}/`, "/");
      }

      // Handle legacy paths
      if (this.shouldUseLegacyPath(versionNumber)) {
        url.pathname = this.legacyPath;
      }

      // Add new version to path if needed
      if (versionNumber && versionNumber !== this.versions.next) {
        url.pathname = `/${versionNumber}${url.pathname}`;
      }

      // Set correct domain
      url.hostname = this.archiveVersions.includes(versionNumber)
        ? "archives.docs.gitlab.com"
        : "docs.gitlab.com";

      return url.toString();
    },
    // Use the legacy Nanoc URL format for versions before the Hugo release.
    // We can drop this when 17.11 comes off the versions menu (20.0 release).
    shouldUseLegacyPath(versionNumber) {
      return (
        this.legacyPath &&
        versionNumber &&
        compareVersions(versionNumber, this.hugoLaunchVersion) < 0
      );
    },
  },
};
</script>

<template>
  <gl-disclosure-dropdown
    :toggle-text="`v${activeVersion()}`"
    class="gl-my-4 lg:gl-my-0 lg:gl-mr-4 lg:gl-ml-3"
    data-testid="versions-menu"
  >
    <gl-disclosure-dropdown-group
      v-for="(group, index) in menuItems"
      :key="index"
      :group="group"
    />
  </gl-disclosure-dropdown>
</template>
